using System;
using System.Net;
using System.Text;
using System.Web;
using System.IO;
using System.Collections;
using System.Windows.Forms;
using System.Data;

	/// <summary>
	/// Allow the transfer of data files using the W3C's specification
	/// for HTTP multipart form data.  Microsoft's version has a bug
	/// where it does not format the ending boundary correctly.
	/// Written by: gregoryp@norvanco.com
	/// </summary>
	/// 


namespace WindowsApplication1
{
	
	public class MultipartForm
	{

		string url;
		StringBuilder postData,response;
		int		countfirst = 0;
		bool postOK;
		
		public  static bool anonymousOnly;
		public static MethodInvoker mivoker;
		public static Form frm;
		public static string [] gridMessage;

		public static StringCollection keywords;
		//public static StringCollection commenttype;
		public static StringCollection comment;
		public static StringCollection urlcoll;
		
		public static int counter=1;
		public static ArrayList VisitedUrls;

        public static UserPass  userpass;
		public static UserPass gridMessagesColl;
		public static bool pingforblogs;
		public static StatusBarPanel  statusBar;
		public static StatusBarPanel statusBar1;

		static MultipartForm ()
		{
             			 
			gridMessage = new  string [] { counter.ToString() ,"this",false.ToString()};
            comment=new StringCollection();
			//commenttype= new StringCollection();
			keywords= new StringCollection();
			userpass= new UserPass();
			VisitedUrls = new ArrayList();
			gridMessagesColl= new UserPass();
			pingforblogs =false;
			
		}



		public static bool PostToBlog(string blogID, string postID,string title,string url)
		{
			MultipartForm mp = new MultipartForm("http://www.blogger.com/login-comment.do");
			
			mp.setField("blogID",blogID);
				
			mp.setField("postID",postID);


		    // anonymousOnly must be credentialsonly				
			if( anonymousOnly)
			{
				mp.setField("iden","Blogger");
				string [] usp = userpass.GetRandom();
				//mp.setField("username",username);
				//mp.setField("password",password);
				mp.setField("username",usp[0]);
				mp.setField("password",usp[1]);
				
			}
			else
			{
				string Page = PostWeb.GetFile("http://www.blogger.com/comment.g?blogID="+blogID+"&postID="+postID);
				if(Page.IndexOf("iden-anon") != -1)
				{
					mp.setField("iden","Anon");
				}
				else
				{
					mp.setField("iden","Blogger");
					string [] usp = userpass.GetRandom();
					//mp.setField("username",username);
					//mp.setField("password",password);
					if( usp[0].Equals("") && usp[1].Equals(""))
						return false;
					mp.setField("username",usp[0]);
					mp.setField("password",usp[1]);
				}
				
			}
			mp.setField("post","Login and Publish");
			//mp.setField("postBody",postBody );
			mp.setField("postBody", comment.GetRandom().Replace("**KEYWORD**", keywords.GetRandom() ) );


			//blogID=6436728&postID=112254078704383269&postBody=this+is+the+esji+slidfj+afdmalisdf+&iden=Anon&username=&password=&anonName=&anonURL=&post=Login+and+Publish
			//mp.sendFile("c:/blank.txt");

			//			richTextBox1.Text= mp.ResponseText.ToString() ;
			//			richTextBox1.Text="Posted";
			mp.Post();

//			MessageBox.Show("aksdjos");

			if( mp.ResponseStatus())
				lock(gridMessage)
				{
					counter++;
					gridMessage=new string [] {counter.ToString(),  "http://www.blogger.com/comment.g?blogID="+blogID+"&postID="+postID, title};
					gridMessagesColl.AddToList( "http://www.blogger.com/comment.g?blogID="+blogID+"&postID="+postID, title);
					frm.Invoke(mivoker);
				}

			if( mp.ResponseStatus() && pingforblogs )
			{
				statusBar1.Text="Pinging with    "+url;
				string str=PostWeb.GetFile("http://pingomatic.com/ping/?title="+title+"&blogurl="+ url + "&chk_weblogscom=on");
			}

			
			return mp.ResponseStatus();
		
		}



		public bool ResponseStatus()
		{
			
			return postOK;
		}

		
		public MultipartForm(string url)
		{
			this.url = url;
			postData = new StringBuilder(30);
			response= new StringBuilder(1000);
			postOK=false;
        
			//    postData = "blogID=16149960&postID=112559463189814985&postBody=this+is+the+tetst&iden=Blogger&username=poiuqwerty&password=poiuqwerty&anonName=&anonURL=&post=Login+and+Publish";
		}

		public void setField(string key, string value)
		{
			if( countfirst==0)
			{
				postData.Append( HttpUtility.UrlEncode( key) + "=" + HttpUtility.UrlEncode( value));
				countfirst++;
			}
			else
				postData.Append("&"+HttpUtility.UrlEncode(key) + "=" + HttpUtility.UrlEncode(value));
            

		}

		public void Post()
		{
			ASCIIEncoding encoding = new ASCIIEncoding();
			byte[] data = encoding.GetBytes(postData.ToString());
			Char [] datas = new Char[120];

        
			try
			{

				// Prepare web request...
				HttpWebRequest myRequest =
					(HttpWebRequest)WebRequest.Create(url);
				myRequest.UserAgent="MOZILLA/5.0 (WINDOWS; U; WINDOWS NT 5.1; EN-US; RV:1.7.12) GECKO/2050915 FIREFOX/1.0.7";
				myRequest.AllowAutoRedirect = true;
				myRequest.CookieContainer = new CookieContainer(100);
				myRequest.Method = "POST";
				myRequest.ContentType = "application/x-www-form-urlencoded";
				myRequest.ContentLength = data.Length;
				Stream newStream = myRequest.GetRequestStream();
				// Send the data.
				//response.Append(postData.ToString());
				//MessageBox.Show(postData.ToString());
				System.Diagnostics.Trace.WriteLine(postData.ToString());

				newStream.Write(data, 0, data.Length);
				newStream.Close();



				Stream receiveStream = myRequest.GetResponse().GetResponseStream();
				Encoding encode = System.Text.Encoding.GetEncoding("utf-8");
				// Pipes the stream to a higher level stream reader with the required encoding format. 
				StreamReader readStream = new StreamReader( receiveStream, encode );
				//Console.WriteLine("\r\nResponse stream received.");
				Char[] read = new Char[256];
				// Reads 256 characters at a time.    
				int count = readStream.Read( read, 0, 256 );
				//			Console.WriteLine("HTML...\r\n");
				while (count > 0) 
				{
					// Dumps the 256 characters on a string and displays the string to the console.
					String str = new String(read, 0, count);
					response.Append (str);
					count = readStream.Read(read, 0, 256);
				}
				//Console.WriteLine("");
				// Releases the resources of the response.
				receiveStream.Close();
				// Releases the resources of the Stream.
				readStream.Close();

			
				String responsestr = response.ToString();
				if( responsestr.IndexOf("Your Comment Has Been Saved") != -1)
					postOK=true;
				else
					postOK=false;

			
				myRequest = null;
			} 
			catch(Exception e) { System.Diagnostics.Trace.WriteLine(e.ToString());}
	
		}

		

		


	}

}