using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.IO;
using System.Text;
using System.Threading;
using System.Text.RegularExpressions;
using System.Diagnostics;
using System.Web;
namespace WindowsApplication1
{
	/// <summary>
	/// Summary description for PostWeb.
	/// </summary>
	public class PostWeb
	{
		public static DataTable  ctrl2;
		public static int numberOfThreads;
		
		public static Thread []threads ;
		static int count=1;
		static int count1=1;

		public static string GetFilePost(string uri, string post)
		{
			// Create a new WebClient instance.
			WebClient myWebClient = new WebClient();
			try
			{
				myWebClient.Headers.Add("Content-Type","application/x-www-form-urlencoded");
			
				// Apply ASCII Encoding to obtain the string as a byte array.
				byte[] byteArray = Encoding.ASCII.GetBytes(post);
				// Upload the input string using the HTTP 1.0 POST method.
				byte[] responseArray = myWebClient.UploadData(uri,"POST",byteArray);
				// Decode and display the response.
				return Encoding.ASCII.GetString(responseArray);
			}
			catch( Exception ex) { Trace.WriteLine(ex.ToString()); return "";}

		}

		public static string  GetFile(string url)
		{
			
			// Create a new WebClient instance.
			WebClient myWebClient = new WebClient();
			
			MultipartForm.statusBar.Text="Downloading "+count++ +")  "+url;
			
			
			// Upload the input string using the HTTP 1.0 POST method.
			try
			{

				byte[] responseArray = myWebClient.DownloadData(url);
				// Decode and display the response.
				return 	Encoding.ASCII.GetString(responseArray);

				
			}
			
			catch (Exception e) { MultipartForm.statusBar.Text="Download of "+url+"Failed"+e.ToString(); Trace.WriteLine(e.ToString()); return " ";}

			

			
		}


		public static void FindAndPost(string url)
		{
			if( MultipartForm.VisitedUrls.Contains(url))
			{
				MultipartForm.statusBar.Text="Already visited ... "+ url;
				Trace.WriteLine("Already visited"+ url);

				return;
			}
			MultipartForm.VisitedUrls.Add(url);
			string Page=GetFile(url);
			StringBuilder  blogID= new StringBuilder(30);
			StringBuilder   postID=new StringBuilder(30);
			
            
			int i=Page.IndexOf("http://www.blogger.com/comment.g?");

	
			// Create a new Regex object and define the regular expression.
			Regex rtitle = new Regex("<title>.*</title>");
			// Use the Matches method to find all matches in the input string.
			MatchCollection mctitle = rtitle.Matches(Page);

            string title="";
			try
			{
				title=mctitle[0].Value.Substring(7,mctitle[0].Value.Length-15);
			}catch (Exception ex){}

            

			if( i != -1)
			{
				int j=Page.IndexOf("blogID=",i);
				j+=7;
				while(  Char.IsDigit(Page[j]))
				{
					blogID.Append(Page[j]);
					j++;
				}
				j=Page.IndexOf("postID=",i);
				j+=7;
				while(  Char.IsDigit(Page[j]))
				{
					postID.Append(Page[j]);
					j++;
				}

				MultipartForm.statusBar1.Text="Posting "+count1.ToString() +"  "+url; 
				if( MultipartForm.PostToBlog(blogID.ToString(),postID.ToString(), title,url))
					MultipartForm.statusBar1.Text="Posting "+count1+ ")SUCCESS   "+ url;
				else
					MultipartForm.statusBar1.Text="Posting "+count1+") FAILED    "+  url;
				count1++;

                //MessageBox.Show(returnstatus.ToString());
				//Trace.WriteLine("   STATUS==="+returnstatus.ToString());
			}
			else
			{
				MatchCollection mc;
				// Create a new Regex object and define the regular expression.
				Regex r = new Regex("http://.*#comments");
				// Use the Matches method to find all matches in the input string.
				mc = r.Matches(Page);

				if( mc.Count > 0)
				{
					Trace.WriteLine( mc[0].Value  );
					FindAndPost(mc[0].Value);
				}
			}

		}



		/// <summary>
		/// crawls blogspot urls searching google
		/// </summary>
		/// <param name="searchstring"></param>
		/// <param name="flag">flag specifying whether searchstring is keyword or url</param>

		public static void  CrawlGoogle(string searchstring,int start )
		{
			//http://www.google.co.in/search?hl=en&q=freelance+programming+site%3Ablogspot.com&btnG=Search&meta=
			//http://www.google.com/search?q=a&num=100&hl=en&lr=&c2coff=1&start=100&sa=N
			//http://www.google.co.in/search?q=thinking&hl=en&lr=&start=20&sa=N

			String Page;
			//Get the page html file
			//http://search.msn.com/results.aspx?srch_type=0&q=comments+site%3Ablogspot.com&first=11&FORM=PERE
			string url="http://www.google.com/search?q="+HttpUtility.UrlEncode(searchstring)+"&num=100&hl=en&lr=&start="+start+"&sa=N";
			//string url="http://search.msn.com/results.aspx?srch_type=0&q="+HttpUtility.UrlEncode(searchstring)+"&first="+start;
			Trace.WriteLine(url);
            Page= GetFile(url);


			ParseLinks(Page);
			Trace.WriteLine(HttpUtility.UrlEncode("freelance programming site:blogspot.com")+"freelance+programming+site%3Ablogspot.com");

			int i=Page.IndexOf((start+100)+"&sa=N");
			// MSN  int i= Page.IndexOf("first="+(start+10));
            Trace.WriteLine("GOOGLE NEXT SEARCH : "+i);
			Page = null;

			if( i != -1)
				CrawlGoogle(searchstring,start+100);

		}

		public static void ParseLinks(string Page)
		{
			
			MatchCollection mc;
			// Create a new Regex object and define the regular expression.
			Regex r = new Regex("<a href=\".*?\"");
			// Use the Matches method to find all matches in the input string.
			mc = r.Matches(Page);
			Page=null;
             threads = new Thread[numberOfThreads ];
			int nthreads=0;
			for(int i=0;i<mc.Count;i++)
			{
				if( mc[i].Value.IndexOf("blogspot.com") != -1 && mc[i].Value.IndexOf("http")!=-1)
				{
					Trace.WriteLine("Crawling ..."+mc[i].Value.Substring(9,mc[i].Value.Length -10) );
					String url=mc[i].Value.Substring(9,mc[i].Value.Length -10);
                    UrlFetcher fetcher= new UrlFetcher(url);
					//if(  numberOfThreads ==1)
					{
						fetcher.Fetch();
					}
					/*else
					{

						threads[nthreads] = new Thread(new ThreadStart(fetcher.Fetch));
						threads[nthreads].Name=url;
						threads[nthreads].IsBackground=true;
						threads[nthreads++].Start();					
						if( nthreads == numberOfThreads )
						{
							for( i=0;i<numberOfThreads ;i++)
							{
								if( threads[i] != null && threads[i].IsAlive)
									threads[i].Join();
				
							}
							nthreads=0;
						}
					}*/
					
				}
			}

			//Waiting second time for threads to complete
			/*if( numberOfThreads != 1)
				for(int i=0;i<numberOfThreads;i++)
				{
					if( threads[i] != null && threads[i].IsAlive)
					threads[i].Join();
					
				}*/

		}




	}
}
